`include "mips.h"

module branch_compare(RSOperand, RTOperand, ComparisonType, Taken, Target);
input	[31:0]	RSOperand;		
input	[31:0]	RTOperand;		
input	[7:0]	ComparisonType;	
output reg Taken;	
output reg [31:0] Target;

always @(*) begin
   case (ComparisonType)
      `select_qc_ne: begin
					 Taken = (RSOperand != RTOperand);
					 Target = 0;
					 end
      `select_qc_eq: begin
					 Taken = (RSOperand == RTOperand);
					 Target = 0;					
					 end
      `select_qc_lez:begin
					 Taken = (RSOperand[31] == 1) | (RSOperand == 0);
					 Target = 0;					
					 end
      `select_qc_gtz:begin
				     Taken = (RSOperand[31] == 0) & (RSOperand != 0);
					 Target = 0;				
					 end
      `select_qc_gez:begin
				 	 Taken = (RSOperand[31] == 0);
					 Target = 0;				
					 end
      `select_qc_ltz:begin
					 Taken = (RSOperand[31] == 1);
					 Target = 0;					
					 end
	  `select_qc_jr: begin
					 Target = RSOperand;
					 Taken = 1;					
				     end
	  `select_qc_jalr:begin
					 Target = RSOperand;
					 Taken = 1;
					 end
      default:		 begin
					 Target = 0;
					 Taken = 0;
					 end
   endcase
end

endmodule		