`include "mips.h"

module decode(instr,operation,operation2,queue,rs,rt,rd,rd2,usesImmediate,immediate,isSyscall,isMem,isMultDiv,isCF,isALU,PC,target,fullFlush);

input [31:0] instr;
input [31:0] PC;
input fullFlush;
output reg [7:0] operation,operation2;
output reg [1:0] queue;
output reg [5:0] rs,rt,rd,rd2;
output reg usesImmediate;
output reg [31:0] immediate;
output reg isSyscall,isMem,isMultDiv,isALU;
output reg [2:0] isCF;
output reg [31:0] target;
wire [31:0] PC4;
assign PC4 = PC+4;

always @(*) begin	
if(fullFlush)begin
	 operation = 0;
	 operation2 = 0;
	 queue = 0;
	 rs = 0;
	 rt = 0;
	 rd = 0;
	 rd2 = 0;
	 immediate = 0; usesImmediate = 0;
	 isSyscall = 0;
	 isMem = 0;
	 isMultDiv = 0;
	 isCF = 0;
	 isALU = 0;
	 target = 0;
end
else begin
    casex({instr[`op], instr[`function], instr[`rt]})
	{`SPECIAL, `ADD,     `dc5 }:begin
								 operation = `select_alu_add;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `ADDU,    `dc5 }:begin
								 operation = `select_alu_add;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `SUB,     `dc5 }:begin
								operation = `select_alu_sub;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `SUBU,    `dc5 }:begin
								operation = `select_alu_sub;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `SLT,     `dc5 }:begin
								 operation = `select_alu_slt;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `SLTU,    `dc5 }:begin
								 operation = `select_alu_sltu;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `AND,     `dc5 }:begin
								 operation = `select_alu_and;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `OR,      `dc5 }:begin
								 operation = `select_alu_or;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `XOR,     `dc5 }:begin
								 operation = `select_alu_xor;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `NOR,     `dc5 }:begin
								 operation = `select_alu_nor;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `SRL,     `dc5 }:begin
								 operation = `select_alu_srl;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = 0;
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = {16'b0, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `SRA,     `dc5 }:begin
								 operation = `select_alu_sra;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = 0;
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = {16'b0, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `SLL,     `dc5 }:begin
								 operation = `select_alu_sll;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = 0;
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = {16'b0, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `SLLV,    `dc5 }:begin
								 operation = `select_alu_sll;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `SRLV,    `dc5 }:begin
								 operation = `select_alu_srl;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `SRAV,    `dc5 }:begin
								 operation = `select_alu_sra;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `JR,      `dc5 }:begin
								 operation = `select_qc_jr;
								 operation2 = 0;
								 queue = `BRQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 1;
								 isALU = 0;
								target = 0;
								end
	{`SPECIAL, `JALR,    `dc5 }:begin
								 operation = `select_qc_jalr;
								 operation2 = 0;
								 queue = `BRQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = PC+8; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 3'b101;
								 isALU = 0;
								target = 0;
								end
	{`SPECIAL, `SYSCALL, `dc5 }:begin
								 operation = 0;
								 operation2 = 0;
								 queue = 0;
								 rs = 0;
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 1;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								 target = PC+4;
								end
	{`SPECIAL, `BREAK,   `dc5 }:begin
								 operation = 0;
								 operation2 = 0;
								 queue = 0;
								 rs = 0;
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	{`SPECIAL, `MULT,    `dc5 }:begin
								 operation = `select_alu_mult_h;
								 operation2 = `select_alu_mult_l;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = 32;
								 rd2 = 33;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 1;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `MULTU,   `dc5 }:begin
								 operation = `select_alu_multu_h;
								 operation2 = `select_alu_multu_l;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = 32;
								 rd2 = 33;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 1;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `DIV,     `dc5 }:begin
								 operation = `select_alu_div_h;
								 operation2 = `select_alu_div_l;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = 32;
								 rd2 = 33;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 1;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `DIVU,    `dc5 }:begin
								 operation = `select_alu_divu_h;
								 operation2 = `select_alu_divu_l;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = 32;
								 rd2 = 33;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 1;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `MFHI,    `dc5 }:begin
								 operation = `select_alu_mfhi;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = 32;
								 rt = 0;
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SPECIAL, `MFLO,    `dc5 }:begin
								 operation = `select_alu_mflo;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = 33;
								 rt = 0;
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`REGIMM, `dc6, `BLTZ}:begin
							 operation = `select_qc_ltz;
								 operation2 = 0;
								 queue = `BRQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = {1'b0,instr[15],1'b1};
								 isALU = 0;
								target = PC4 + {{14{instr[15]}}, instr[`immediate], 2'b0};
							end
	{`REGIMM, `dc6, `BGEZ}:begin
							 operation = `select_qc_gez;
								 operation2 = 0;
								 queue = `BRQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = {1'b0,instr[15],1'b1};
								 isALU = 0;
								 target = PC4 + {{14{instr[15]}}, instr[`immediate], 2'b0};
							end
	{`REGIMM, `dc6, `BGEZAL}: begin
								 operation = `select_qc_gez;
								 operation2 = 0;
								 queue = `BRQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = PC+8; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = {1'b1,instr[15],1'b1};
								 isALU = 0;
								target = PC4 + {{14{instr[15]}}, instr[`immediate], 2'b0};
								end
	{`REGIMM, `dc6, `BLTZAL}: begin
								 operation = `select_qc_ltz;
								 operation2 = 0;
								 queue = `BRQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rd];
								 rd2 = 0;
								 immediate = PC+8; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = {1'b1,instr[15],1'b1};
								 isALU = 0;
								target = PC4 + {{14{instr[15]}}, instr[`immediate], 2'b0};
								end
	{`ADDI,	 `dc6, `dc5 }: begin
								 operation = `select_alu_add;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`ADDIU, `dc6, `dc5 }: begin
								 operation = `select_alu_add;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SLTI,	 `dc6, `dc5 }: begin
								 operation = `select_alu_slt;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`SLTIU, `dc6, `dc5 }: begin
								 operation = `select_alu_sltu;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`ANDI,	 `dc6, `dc5 }: begin
								 operation = `select_alu_and;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {16'b0, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`ORI,	 `dc6, `dc5 }: begin
								 operation = `select_alu_or;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {16'b0, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`XORI,	 `dc6, `dc5 }: begin
								 operation = `select_alu_xor;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {16'b0, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`LUI,	 `dc6, `dc5 }: begin
								 operation = `select_alu_or;
								 operation2 = 0;
								 queue = `ALUQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {instr[`immediate], 16'b0}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 1;
								target = PC+4;
								end
	{`LW,	 `dc6, `dc5 }: begin
								 operation = `select_mem_lw;
								 operation2 = 0;
								 queue = `MEMQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 1;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	{`LHU,   `dc6, `dc5 }: begin
								 operation = `select_mem_lhu;
								 operation2 = 0;
								 queue = `MEMQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 1;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	{`LH,    `dc6, `dc5 }: begin
								 operation = `select_mem_lh;
								 operation2 = 0;
								 queue = `MEMQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 1;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	{`LBU,	 `dc6, `dc5 }: begin
								 operation = `select_mem_lbu;
								 operation2 = 0;
								 queue = `MEMQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 1;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	{`LB,	 `dc6, `dc5 }: begin
								 operation = `select_mem_lb;
								 operation2 = 0;
								 queue = `MEMQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = instr[`rt];
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 1;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	{`SW,	 `dc6, `dc5 }: begin
								 operation = `select_mem_sw;
								 operation2 = 0;
								 queue = `MEMQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = 0;
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 1;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	{`SH,    `dc6, `dc5 }: begin
								 operation = `select_mem_sh;
								 operation2 = 0;
								 queue = `MEMQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = 0;
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 1;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	{`SB,	 `dc6, `dc5 }: begin
								 operation = `select_mem_sb;
								 operation2 = 0;
								 queue = `MEMQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = 0;
								 rd2 = 0;
								 immediate = {{16{instr[15]}}, instr[`immediate]}; usesImmediate = 1;
								 isSyscall = 0;
								 isMem = 1;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	{`J,	 `dc6, `dc5 }: begin
								 operation = `select_qc_j;
								 operation2 = 0;
								 queue = 0;
								 rs = 0;
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 1;
								 isALU = 0;
								target = {PC4[31:28],instr[`target],2'b0};
								end
	{`JAL,	 `dc6, `dc5 }: begin
								 operation = `select_qc_jal;
								 operation2 = 0;
								 queue = 0;
								 rs = 0;
								 rt = 0;
								 rd = 31;
								 rd2 = 0;
								 immediate = PC+8; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 3'b101;
								 isALU = 0;
								target = {PC4[31:28],instr[`target],2'b0};
								end
	{`BNE,	 `dc6, `dc5 }: begin
								 operation = `select_qc_ne;
								 operation2 = 0;
								 queue = `BRQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = 0;
								 rd2 = 0;
								 immediate = {{14{instr[15]}}, instr[`immediate], 2'b0}; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = {1'b0,instr[15],1'b1};
								 isALU = 0;
								target = PC4 + {{14{instr[15]}}, instr[`immediate], 2'b0};
								end
	{`BEQ,	 `dc6, `dc5 }: begin
								 operation = `select_qc_eq;
								 operation2 = 0;
								 queue = `BRQueue;
								 rs = instr[`rs];
								 rt = instr[`rt];
								 rd = 0;
								 rd2 = 0;
								 immediate = {{14{instr[15]}}, instr[`immediate], 2'b0}; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = {1'b0,instr[15],1'b1};
								 isALU = 0;
								target = PC4 + {{14{instr[15]}}, instr[`immediate], 2'b0};
								end
	{`BLEZ,	 `dc6, `dc5 }: begin
								 operation = `select_qc_lez;
								 operation2 = 0;
								 queue = `BRQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = {{14{instr[15]}}, instr[`immediate], 2'b0}; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = {1'b0,instr[15],1'b1};
								 isALU = 0;
								target = PC4 + {{14{instr[15]}}, instr[`immediate], 2'b0};
								end
	{`BGTZ,	 `dc6, `dc5 }: begin
								 operation = `select_qc_gtz;
								 operation2 = 0;
								 queue = `BRQueue;
								 rs = instr[`rs];
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = {{14{instr[15]}}, instr[`immediate], 2'b0}; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = {1'b0,instr[15],1'b1};
								 isALU = 0;
								target = PC4 + {{14{instr[15]}}, instr[`immediate], 2'b0};
								end
	
	// These are passed thru as NOPs so that real
	// program may run.
	{`LWC1,	 `dc6, `dc5 }: begin
								 operation = 0;
								 operation2 = 0;
								 queue = 0;
								 rs = 0;
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	{`SWC1,	 `dc6, `dc5 }: begin
								 operation = 0;
								 operation2 = 0;
								 queue = 0;
								 rs = 0;
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	{`COP1,	 `dc6, `dc5 }: begin
								 operation = 0;
								 operation2 = 0;
								 queue = 0;
								 rs = 0;
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
								end
	
	default:
	  begin
								 operation = 0;
								 operation2 = 0;
								 queue = 0;
								 rs = 0;
								 rt = 0;
								 rd = 0;
								 rd2 = 0;
								 immediate = 0; usesImmediate = 0;
								 isSyscall = 0;
								 isMem = 0;
								 isMultDiv = 0;
								 isCF = 0;
								 isALU = 0;
								target = PC+4;
	  end
    endcase

   end
end
endmodule