`include "mips.h"

module freelist(RESET,CLK,numRequest,numFree,free0,free1,free2,free3,numAdd,nowFree0,nowFree1,nowFree2,nowFree3);
input RESET,CLK;
input [2:0] numRequest;
output reg [7:0] numFree;
output [5:0] free0,free1,free2,free3;
input [2:0] numAdd;
input [5:0] nowFree0,nowFree1,nowFree2,nowFree3;
reg [31:0] total_free;
reg [5:0] freeRegisters[29:0];
reg [5:0] head,tail;//add at tail, remove from head
reg [2:0] nonZero;

assign free3 = freeRegisters[head];
assign free2 = freeRegisters[(head+30-1)%30];
assign free1 = freeRegisters[(head+30-2)%30];
assign free0 = freeRegisters[(head+30-3)%30];

integer i;

always @(negedge CLK)begin
	if(RESET)begin
		for(i=0;i<30;i=i+1)freeRegisters[i]=i+34;
		head = 3;
		tail = 0;
		numFree = 30;
		total_free = 0;
	end
	else begin

		nonZero = 0;
		if(nowFree0)begin
			freeRegisters[tail] = nowFree0;
			tail = tail + 1;
			if(tail==30)tail=0;
			nonZero = nonZero + 1;
		end
		if(nowFree1)begin
			freeRegisters[tail] = nowFree1;
			tail = tail + 1;
			if(tail==30)tail=0;
			nonZero = nonZero + 1;			
		end
		if(nowFree2)begin
			freeRegisters[tail] = nowFree2;
			tail = tail + 1;
			if(tail==30)tail=0;
			nonZero = nonZero + 1;			
		end
		if(nowFree3)begin
			freeRegisters[tail] = nowFree3;
			tail = tail + 1;
			if(tail==30)tail=0;
			nonZero = nonZero + 1;			
		end
		
		numFree = numFree - numRequest + nonZero;
		total_free = total_free + numFree;
		head = head + numRequest;
		if(head>=30)head=head-30;
	end
end

endmodule