`include "mips.h"

module physical_register_file(RESET,CLK,ReadAddr0,ReadValue0,ReadAddr1,ReadValue1,
							  			ReadAddr2,ReadValue2,ReadAddr3,ReadValue3,
							  			ReadAddr4,ReadValue4,ReadAddr5,ReadValue5,
							  			ReadAddr6,ReadValue6,ReadAddr7,ReadValue7,
										WriteValue0,WriteAddr0,WriteEnable0,
										WriteValue1,WriteAddr1,WriteEnable1,
										WriteValue2,WriteAddr2,WriteEnable2,
										WriteValue3,WriteAddr3,WriteEnable3);
							
//Read0,1 ALU0
//Read2,3 ALU1
//Read4,5 LDST
//Read6,7 Br/Jr
//Write0 ALU0, two cycle write for mult/div
//Write1 ALU1, two cycle write for mult/div
//Write2 LD
//Write3 Link, could combine with load

input RESET,CLK;
input [5:0] ReadAddr0;
output reg [31:0] ReadValue0;
input [5:0] ReadAddr1;
output reg [31:0] ReadValue1;
input [5:0] ReadAddr2;
output reg [31:0] ReadValue2;
input [5:0] ReadAddr3;
output reg [31:0] ReadValue3;
input [5:0] ReadAddr4;
output reg [31:0] ReadValue4;
input [5:0] ReadAddr5;
output reg [31:0] ReadValue5;
input [5:0] ReadAddr6;
output reg [31:0] ReadValue6;
input [5:0] ReadAddr7;
output reg [31:0] ReadValue7;
input WriteEnable0;
input [5:0] WriteAddr0;
input [31:0] WriteValue0;
input WriteEnable1;
input [5:0] WriteAddr1;
input [31:0] WriteValue1;
input WriteEnable2;
input [5:0] WriteAddr2;
input [31:0] WriteValue2;
input WriteEnable3;
input [5:0] WriteAddr3;
input [31:0] WriteValue3;

reg	[31:0]	RegFile [63:0];

always @(RegFile[ReadAddr0])begin
	ReadValue0 = RegFile[ReadAddr0];
end
always @(RegFile[ReadAddr1])begin
	ReadValue1 = RegFile[ReadAddr1];
end
always @(RegFile[ReadAddr2])begin
	ReadValue2 = RegFile[ReadAddr2];
end
always @(RegFile[ReadAddr3])begin
	ReadValue3 = RegFile[ReadAddr3];
end
always @(RegFile[ReadAddr4])begin
	ReadValue4 = RegFile[ReadAddr4];
end
always @(RegFile[ReadAddr5])begin
	ReadValue5 = RegFile[ReadAddr5];
end
always @(RegFile[ReadAddr6])begin
	ReadValue6 = RegFile[ReadAddr6];
end
always @(RegFile[ReadAddr7])begin
	ReadValue7 = RegFile[ReadAddr7];
end

integer i;

always @(negedge CLK)begin
	if(RESET)begin
		for(i=0;i<64;i=i+1)RegFile[i]=0;
	end
	else begin
		if(WriteEnable0 && WriteAddr0!=0)RegFile[WriteAddr0]=WriteValue0;
		if(WriteEnable1 && WriteAddr1!=0)RegFile[WriteAddr1]=WriteValue1;
		if(WriteEnable2 && WriteAddr2!=0)RegFile[WriteAddr2]=WriteValue2;
		if(WriteEnable3 && WriteAddr3!=0)RegFile[WriteAddr3]=WriteValue3;
	end
end

endmodule

module ready_register_list(RESET,CLK,toBeReady0,toBeReady1,toBeReady2,toBeReady3,clearReady0,clearReady1,clearReady2,clearReady3,ReadyList,fullFlush);
input RESET;
input CLK;
input [63:0] toBeReady0;
input [63:0] toBeReady1;
input [63:0] toBeReady2;
input [63:0] toBeReady3;
input [63:0] clearReady0;
input [63:0] clearReady1;
input [63:0] clearReady2;
input [63:0] clearReady3;
input fullFlush;
output reg [63:0] ReadyList;

always @(posedge CLK)begin
	if(RESET)begin
		ReadyList = 0;
	end
	else begin
		if(!fullFlush)ReadyList = ReadyList | toBeReady0 | toBeReady1 | toBeReady2;
		ReadyList = ReadyList | toBeReady3;//add new ready registers
		ReadyList = ReadyList & ~clearReady0 & ~clearReady1 & ~clearReady2 & ~clearReady3;//clear retired registers (or flush) 		
		ReadyList = ReadyList | 64'h0000000000000001;
	end
end

endmodule