`include "mips.h"

module rename(RESET,CLK,fullFlush,numInstr,replacementMAP,numFree,renameStall,numRenamed,iStalled,
										   inRS0,inRT0,inRD0,outRS0,outRT0,outRD0,free0,
										   inRS1,inRT1,inRD1,outRS1,outRT1,outRD1,free1,
										   inRS2,inRT2,inRD2,outRS2,outRT2,outRD2,free2,
										   inRS3,inRT3,inRD3,outRS3,outRT3,outRD3,free3,
										   ab_swap,bc_swap,cd_swap,ab_dependant,bc_dependant,cd_dependant);
input RESET,CLK,fullFlush,iStalled;
input [2:0] numInstr;
input [203:0] replacementMAP;
input [7:0] numFree;
input ab_swap,bc_swap,cd_swap;
output renameStall;
reg [5:0] newMAP[33:0];
input [5:0] inRS0,inRT0,inRD0,inRS1,inRT1,inRD1,inRS2,inRT2,inRD2,inRS3,inRT3,inRD3,free0,free1,free2,free3;
output reg [5:0] outRS0,outRT0,outRD0,outRS1,outRT1,outRD1,outRS2,outRT2,outRD2,outRS3,outRT3,outRD3;
output reg [2:0] numRenamed;
output reg ab_dependant,bc_dependant,cd_dependant;
reg [5:0] MAP[33:0];
reg ab_l,bc_l,cd_l;
wire bothab,bothbc,bothcd;

assign bothab = ab_dependant&ab_l;
assign bothbc = bc_dependant&bc_l;
assign bothcd = cd_dependant&cd_l;

assign renameStall = numFree < 4;

always @(*)begin
	ab_dependant = 0;
	bc_dependant = 0;
	cd_dependant = 0;
	ab_l = 0;
	bc_l = 0;
	cd_l = 0;
	if(ab_swap)begin
		if(inRD0 && (inRD0 == inRS1 || inRD0 == inRT1 || inRD0 == inRD1))ab_dependant = 1;
		else ab_dependant = 0;
		if(inRD1 && (inRD1 == inRS0 || inRD1 == inRT0 || inRD1 == inRD0))ab_l = 1;
		else ab_l = 0;
	end
	if(bc_swap)begin
		if(inRD1 && (inRD1 == inRS2 || inRD1 == inRT2 || inRD1 == inRD2))bc_dependant = 1;
		else bc_dependant = 0;
		if(inRD2 && (inRD2 == inRS1 || inRD2 == inRT1 || inRD2 == inRD1))bc_l = 1;
		else bc_l = 0;
	end
	if(cd_swap)begin
		if(inRD2 && (inRD2 == inRS3 || inRD2 == inRT3 || inRD2 == inRD3))cd_dependant = 1;
		else cd_dependant = 0;
		if(inRD3 && (inRD3 == inRS2 || inRD3 == inRT2 || inRD3 == inRD2))cd_l = 1;
		else cd_l = 0;
	end
end

integer i;

always @(*)begin
	newMAP[0] = replacementMAP[5:0];
	newMAP[1] = replacementMAP[11:6];
	newMAP[2] = replacementMAP[17:12];
	newMAP[3] = replacementMAP[23:18];
	newMAP[4] = replacementMAP[29:24];
	newMAP[5] = replacementMAP[35:30];
	newMAP[6] = replacementMAP[41:36];
	newMAP[7] = replacementMAP[47:42];
	newMAP[8] = replacementMAP[53:48];
	newMAP[9] = replacementMAP[59:54];
	newMAP[10] = replacementMAP[65:60];
	newMAP[11] = replacementMAP[71:66];
	newMAP[12] = replacementMAP[77:72];
	newMAP[13] = replacementMAP[83:78];
	newMAP[14] = replacementMAP[89:84];
	newMAP[15] = replacementMAP[95:90];
	newMAP[16] = replacementMAP[101:96];
	newMAP[17] = replacementMAP[107:102];
	newMAP[18] = replacementMAP[113:108];
	newMAP[19] = replacementMAP[119:114];
	newMAP[20] = replacementMAP[125:120];
	newMAP[21] = replacementMAP[131:126];
	newMAP[22] = replacementMAP[137:132];
	newMAP[23] = replacementMAP[143:138];
	newMAP[24] = replacementMAP[149:144];
	newMAP[25] = replacementMAP[155:150];
	newMAP[26] = replacementMAP[161:156];
	newMAP[27] = replacementMAP[167:162];
	newMAP[28] = replacementMAP[173:168];
	newMAP[29] = replacementMAP[179:174];
	newMAP[30] = replacementMAP[185:180];
	newMAP[31] = replacementMAP[191:186];
	newMAP[32] = replacementMAP[197:192];
	newMAP[33] = replacementMAP[203:198];
end

always @(posedge CLK)begin
	if(RESET)begin
		for(i=0;i<34;i=i+1)begin
			MAP[i] = i;

		end
		outRS0 = 0; outRT0 = 0; outRD0 = 0;
		outRS1 = 0; outRT1 = 0; outRD1 = 0;
		outRS2 = 0; outRT2 = 0; outRD2 = 0;
		outRS3 = 0; outRT3 = 0; outRD3 = 0;
		numRenamed = 0;
	end
	else begin
		if(fullFlush)begin
			for(i=0;i<34;i=i+1)begin
				MAP[i] = newMAP[i];

			end
			outRS0 = 0; outRT0 = 0; outRD0 = 0;
			outRS1 = 0; outRT1 = 0; outRD1 = 0;
			outRS2 = 0; outRT2 = 0; outRD2 = 0;
			outRS3 = 0; outRT3 = 0; outRD3 = 0;
			numRenamed = 0;
		end 
		else begin
			if(renameStall)begin
				outRS0 = 0; outRT0 = 0; outRD0 = 0;
				outRS1 = 0; outRT1 = 0; outRD1 = 0;
				outRS2 = 0; outRT2 = 0; outRD2 = 0;
				outRS3 = 0; outRT3 = 0; outRD3 = 0;
				numRenamed = 0;
			end
			else begin
				outRS0 = 0; outRT0 = 0; outRD0 = 0;
				outRS1 = 0; outRT1 = 0; outRD1 = 0;
				outRS2 = 0; outRT2 = 0; outRD2 = 0;
				outRS3 = 0; outRT3 = 0; outRD3 = 0;
				case(numInstr)
					3'd0:begin
						 numRenamed = 0;
						 end
					3'd1:begin
						 numRenamed = 0;
						 outRS0 = MAP[inRS0];
						 outRT0 = MAP[inRT0];
							if(inRD0)begin
							case(numRenamed)
							 3'd0:begin
									outRD0 = free0;
									MAP[inRD0] = free0;
								  end
							 3'd1:begin
								  end
							 3'd2:begin
							      end
							 3'd3:begin
							 	  end
							 default:begin
									 end
	 						 endcase
							 numRenamed = numRenamed + 1;
							end
							else begin
							 outRD0 = 0;
							end
						 end	
					3'd2:begin
						if(ab_swap)begin
							 numRenamed = 0;
							 outRS1 = MAP[inRS1];
							 outRT1 = MAP[inRT1];
								if(inRD1)begin
								case(numRenamed)
								 3'd0:begin
										outRD1 = free0;
										MAP[inRD1] = free0;
									  end
								 3'd1:begin
									  end
								 3'd2:begin
								      end
								 3'd3:begin
								 	  end
								 default:begin
										 end
		 						 endcase
								 numRenamed = numRenamed + 1;
								end
								else begin
								 outRD1 = 0;
								end
							 outRS0 = MAP[inRS0];
							 outRT0 = MAP[inRT0];
								if(inRD0)begin
								case(numRenamed)
								 3'd0:begin
										outRD0 = free0;
										MAP[inRD0] = free0;
									  end
								 3'd1:begin
										outRD0 = free1;
										MAP[inRD0] = free1;
									  end
								 3'd2:begin
								      end
								 3'd3:begin
								 	  end
								 default:begin
										 end
		 						 endcase
								 numRenamed = numRenamed + 1;
								end
								else begin
								 outRD0 = 0;
								end
						end
						else begin
							 numRenamed = 0;
							 outRS0 = MAP[inRS0];
							 outRT0 = MAP[inRT0];
								if(inRD0)begin
								case(numRenamed)
								 3'd0:begin
										outRD0 = free0;
										MAP[inRD0] = free0;
									  end
								 3'd1:begin
									  end
								 3'd2:begin
								      end
								 3'd3:begin
								 	  end
								 default:begin
										 end
		 						 endcase
								 numRenamed = numRenamed + 1;
								end
								else begin
								 outRD0 = 0;
								end
							 outRS1 = MAP[inRS1];
							 outRT1 = MAP[inRT1];
								if(inRD1)begin
								case(numRenamed)
								 3'd0:begin
										outRD1 = free0;
										MAP[inRD1] = free0;
									  end
								 3'd1:begin
										outRD1 = free1;
										MAP[inRD1] = free1;
									  end
								 3'd2:begin
								      end
								 3'd3:begin
								 	  end
								 default:begin
										 end
		 						 endcase
								 numRenamed = numRenamed + 1;
								end
								else begin
								 outRD1 = 0;
								end
							 end
						end
					3'd3:begin
						 numRenamed = 0;
						 outRS0 = MAP[inRS0];
						 outRT0 = MAP[inRT0];
							if(inRD0)begin
							case(numRenamed)
							 3'd0:begin
									outRD0 = free0;
									MAP[inRD0] = free0;
								  end
							 3'd1:begin
								  end
							 3'd2:begin
							      end
							 3'd3:begin
							 	  end
							 default:begin
									 end
	 						 endcase
							 numRenamed = numRenamed + 1;
							end
							else begin
							 outRD0 = 0;
							end
							if(bc_swap)begin
								 outRS2 = MAP[inRS2];
								 outRT2 = MAP[inRT2];
									if(inRD2)begin
									case(numRenamed)
									 3'd0:begin
											outRD2 = free0;
											MAP[inRD2] = free0;
										  end
									 3'd1:begin
											outRD2 = free1;
											MAP[inRD2] = free1;
										  end
									 3'd2:begin
									      end
									 3'd3:begin
									 	  end
									 default:begin
											 end
			 						 endcase
									 numRenamed = numRenamed + 1;
									end
									else begin
									 outRD2 = 0;
									end
								 outRS1 = MAP[inRS1];
								 outRT1 = MAP[inRT1];
									if(inRD1)begin
									case(numRenamed)
									 3'd0:begin
											outRD1 = free0;
											MAP[inRD1] = free0;
										  end
									 3'd1:begin
											outRD1 = free1;
											MAP[inRD1] = free1;
										  end
									 3'd2:begin
											outRD1 = free2;
											MAP[inRD1] = free2;							
									      end
									 3'd3:begin
									 	  end
									 default:begin
											 end
			 						 endcase
									 numRenamed = numRenamed + 1;
									end
									else begin
									 outRD1 = 0;
									end
							end
							else begin
								 outRS1 = MAP[inRS1];
								 outRT1 = MAP[inRT1];
									if(inRD1)begin
									case(numRenamed)
									 3'd0:begin
											outRD1 = free0;
											MAP[inRD1] = free0;
										  end
									 3'd1:begin
											outRD1 = free1;
											MAP[inRD1] = free1;
										  end
									 3'd2:begin
									      end
									 3'd3:begin
									 	  end
									 default:begin
											 end
			 						 endcase
									 numRenamed = numRenamed + 1;
									end
									else begin
									 outRD1 = 0;
									end
								 outRS2 = MAP[inRS2];
								 outRT2 = MAP[inRT2];
									if(inRD2)begin
									case(numRenamed)
									 3'd0:begin
											outRD2 = free0;
											MAP[inRD2] = free0;
										  end
									 3'd1:begin
											outRD2 = free1;
											MAP[inRD2] = free1;
										  end
									 3'd2:begin
											outRD2 = free2;
											MAP[inRD2] = free2;							
									      end
									 3'd3:begin
									 	  end
									 default:begin
											 end
			 						 endcase
									 numRenamed = numRenamed + 1;
									end
									else begin
									 outRD2 = 0;
									end
							end
						 end
					3'd4:begin
						 numRenamed = 0;
						 outRS0 = MAP[inRS0];
						 outRT0 = MAP[inRT0];
							if(inRD0)begin
							case(numRenamed)
							 3'd0:begin
									outRD0 = free0;
									MAP[inRD0] = free0;
								  end
							 3'd1:begin
								  end
							 3'd2:begin
							      end
							 3'd3:begin
							 	  end
							 default:begin
									 end
	 						 endcase
							 numRenamed = numRenamed + 1;
							end
							else begin
							 outRD0 = 0;
							end
						 outRS1 = MAP[inRS1];
						 outRT1 = MAP[inRT1];
							if(inRD1)begin
							case(numRenamed)
							 3'd0:begin
									outRD1 = free0;
									MAP[inRD1] = free0;
								  end
							 3'd1:begin
									outRD1 = free1;
									MAP[inRD1] = free1;
								  end
							 3'd2:begin
							      end
							 3'd3:begin
							 	  end
							 default:begin
									 end
	 						 endcase
							 numRenamed = numRenamed + 1;
							end
							else begin
							 outRD1 = 0;
							end
							if(cd_swap)begin
								 outRS3 = MAP[inRS3];
								 outRT3 = MAP[inRT3];
									if(inRD3)begin
									case(numRenamed)
									 3'd0:begin
											outRD3 = free0;
											MAP[inRD3] = free0;
										  end
									 3'd1:begin
											outRD3 = free1;
											MAP[inRD3] = free1;
										  end
									 3'd2:begin
											outRD3 = free2;
											MAP[inRD3] = free2;							
									      end
									 3'd3:begin
									 	  end
									 default:begin
											 end
			 						 endcase
									 numRenamed = numRenamed + 1;
									end
									else begin
									 outRD3 = 0;
									end
								 outRS2 = MAP[inRS2];
								 outRT2 = MAP[inRT2];
									if(inRD2)begin
									case(numRenamed)
									 3'd0:begin
											outRD2 = free0;
											MAP[inRD2] = free0;
										  end
									 3'd1:begin
											outRD2 = free1;
											MAP[inRD2] = free1;
										  end
									 3'd2:begin
											outRD2 = free2;
											MAP[inRD2] = free2;							
									      end
									 3'd3:begin
											outRD2 = free3;
											MAP[inRD2] = free3;														
									 	  end
									 default:begin
											 end
			 						 endcase
									 numRenamed = numRenamed + 1;
									end
									else begin
									 outRD2 = 0;
									end
							end
							else begin
							 outRS2 = MAP[inRS2];
							 outRT2 = MAP[inRT2];
								if(inRD2)begin
								case(numRenamed)
								 3'd0:begin
										outRD2 = free0;
										MAP[inRD2] = free0;
									  end
								 3'd1:begin
										outRD2 = free1;
										MAP[inRD2] = free1;
									  end
								 3'd2:begin
										outRD2 = free2;
										MAP[inRD2] = free2;							
								      end
								 3'd3:begin
								 	  end
								 default:begin
										 end
		 						 endcase
								 numRenamed = numRenamed + 1;
								end
								else begin
								 outRD2 = 0;
								end
							 outRS3 = MAP[inRS3];
							 outRT3 = MAP[inRT3];
								if(inRD3)begin
								case(numRenamed)
								 3'd0:begin
										outRD3 = free0;
										MAP[inRD3] = free0;
									  end
								 3'd1:begin
										outRD3 = free1;
										MAP[inRD3] = free1;
									  end
								 3'd2:begin
										outRD3 = free2;
										MAP[inRD3] = free2;							
								      end
								 3'd3:begin
										outRD3 = free3;
										MAP[inRD3] = free3;														
								 	  end
								 default:begin
										 end
		 						 endcase
								 numRenamed = numRenamed + 1;
								end
								else begin
								 outRD3 = 0;
								end
							end
						 end
					default: begin
							 numRenamed = 0;
							 end		
					endcase			
			end
		end	
	end
end

endmodule
