`include "mips.h"

module return_address_stack(RESET,CLK,push,pop,LinkPC,PredPC,incorrect_pushes,incorrect_pops);
input RESET;
input CLK;
input push;
input pop;
input [31:0] LinkPC;
output reg [31:0] PredPC;
reg [31:0] predStack[15:0];
reg [3:0] count;
reg [31:0] missed;
input [2:0] incorrect_pops,incorrect_pushes;
reg [2:0] add_pops,remove_pushes;
reg [31:0] total_occupancy,max_fullness;


integer i;

always @(posedge CLK)begin
	if(RESET)begin
		count = 0;
		missed = 0;
		for(i=0;i<16;i=i+1)begin
			predStack[i] = 0;
		end
		PredPC = 0;
		total_occupancy = 0;
		max_fullness = 0;
	end
	else begin	
		add_pops = incorrect_pops;
		remove_pushes = incorrect_pushes;
		for(i=0;i<4;i=i+1)begin
			if(add_pops)begin
				if(count != 15)begin
					count = count + 1;
				end
				else begin 
					missed = missed + 1;			
				end
				add_pops = add_pops - 1;
			end
		end
		for(i=0;i<4;i=i+1)begin
			if(remove_pushes)begin
				if(missed != 0)begin
					missed = missed - 1;
				end
				else begin
					if(count != 0)begin
						count = count - 1;
					end			
				end
				remove_pushes = remove_pushes - 1;
			end
		end
		if(count!=0)PredPC = predStack[count-1];
		if(pop)begin
			if(missed != 0)begin
				missed = missed - 1;
			end
			else begin
				if(count != 0)begin
					count = count - 1;
				end			
			end
		end
		if(push)begin
			if(count != 15)begin
				predStack[count]=LinkPC;
				count = count + 1;
			end
			else begin 
				missed = missed + 1;			
			end
		end
		total_occupancy = total_occupancy + count+missed;
		if(count+missed > max_fullness)max_fullness = count+missed;
	end
end

endmodule